/* eslint-disable no-console */
const fs = require('fs/promises')
const path = require('path')
const pathToRegexp = require('path-to-regexp') // peerDependency? ->

const CRITICAL_CSS_DIR = 'critical-css'

const cache = {}
let defaultManifest = {}
try {
  const defaultManifestPath = path.join(
    process.cwd(),
    './critical-css/critical.json'
  )
  console.log(defaultManifestPath)
  defaultManifest = require.resolve(defaultManifestPath)
  console.log('after require default manifest')
} catch (e) {
  console.log(e)
}

const getFilePath = file => path.join(process.cwd(), CRITICAL_CSS_DIR, file)

console.log({defaultManifest})
console.log('---------------')

module.exports = ({
  deviceType: type = 'mobile',
  manifest = defaultManifest
}) => async (req, res, next) => {
  console.log('-> critical-css-static-middleware')
  // move to sui-ssr this line
  // if (legacyCriticalEnabled) return next()

  // move to each server
  // const ua = parser(req.headers['user-agent'])
  // const {type} = ua.device
  // console.log({type})

  if (type !== 'mobile') return next()

  console.log({requestPath: req.path})

  const criticalPath = Object.keys(manifest).find(path => {
    const regexp = pathToRegexp(path)
    return Boolean(regexp.exec(req && req.path))
  })

  console.log({criticalPath})

  if (!criticalPath) return next()

  console.log({cache})

  if (cache[criticalPath]) {
    req.criticalCSS = cache[criticalPath]
    return next()
  }

  const file = manifest[criticalPath]
  const filePath = file && getFilePath(file)

  console.log({filePath})

  const err = await fs.access(filePath, fs.F_OK)
  console.log({err})

  if (!err) {
    try {
      const criticalCSS = await fs.readFile(filePath, 'utf8')
      req.criticalCSS = criticalCSS
      cache[criticalPath] = criticalCSS
    } catch (e) {
      console.error(e)
    }
  }

  next()
}
